#include "hmg.ch"
#INCLUDE "Dbstruct.ch"
#INCLUDE "ADORDD.ch"
#INCLUDE "Error.ch"
#INCLUDE "DbInfo.ch"

#define adColNullAble 2

*********************************************************
*
* USE MyDBF
* ADOxlsxWrite( "C:\TEMP\","MYFILE",".XLSX")
*
*********************************************************

FUNCTION ADOxlsxWrite( cText_Path, cText_Name, cText_Ext )

LOCAL bError, oError
LOCAL oConnect, oCatalog, oTable, oColumn, objRS
LOCAL aStructure, ii, iMax, xValue, cOldLang
LOCAL nMax, nEvery, nProz
LOCAL cField, nPosi, cType, cLine, nLen, nDec, cSql, cSelect, nStart, nStop
LOCAL myXlsFile
LOCAL mySheet    := "Sheet1"
LOCAL aValue     := {}
LOCAL aField     := {}
LOCAL nRowLine := 1

   myXlsFile := cText_Path + cText_Name + cText_Ext

   IF FILE( myXlsFile )
      FERASE( myXlsFile )
   ENDIF

   IF USED()
      aStructure := SP_aDbfStruct()
      IF EMPTY( aStructure )
         MsgInfo( "Error empty Structure,no FIELDs" )
         RETURN .F.
      ENDIF
      iMax := LEN( aStructure )

      // count for progressbar when have Filter/Scope
      // nMax := 0
      // GO TOP
      // DO WHILE !EOF()
      //    nMax ++
      //    SKIP
      // ENDDO
      nMax := DBORDERINFO( DBOI_KEYCOUNT )       // harbour
      nEvery := ROUND( nMax / 100, 0 )
      Ondummy( TIME(), nMax, nEvery )
   ELSE
      msgInfo( "need DBF" )
      RETURN .F.
   ENDIF

   cOldLang := hb_cdpSelect( 'UTF8EX' )

   SET CENTURY ON
   SET DATE GERMAN
   //  SET DATE FORMAT "dd.mm.yyyy"

   oConnect := CreateObject( "ADODB.Connection" )

   bError := ERRORBLOCK( { | oErr | BREAK( oErr ) } )
   BEGIN SEQUENCE
      oConnect:Execute( "DROP TABLE " + myXlsFile )
   END SEQUENCE
   ERRORBLOCK( bError )

   //  ---------------------- Catalog -------------------------- *

   oCatalog := CreateObject( "ADOX.Catalog" )
   oCatalog:ActiveConnection := 'Provider=Microsoft.ACE.OLEDB.12.0;' + ;
                                'Data Source=' + myXlsFile + ';' + ;
                                'Extended Properties="Excel 12.0 Xml";'

   //  ---------------------- Create Table --------------------- *

   oTable := CreateObject( "ADOX.Table" )
   oTable:Name := "Sheet1"

   ii := 1
   FOR ii := 1 TO iMax
      cField := aStructure[ ii ] [ DBS_NAME ]
      cType := aStructure[ ii ] [ DBS_TYPE ]

      oColumn := CreateObject( "ADOX.Column" )
      oColumn:Name := cField

      DO CASE
         CASE cType = "C" ; oColumn:Type := adVarWChar
         CASE cType = "M" ; oColumn:Type := adLongVarWChar
         CASE cType = "N" ; oColumn:Type := adDouble
         CASE cType = "D" ; oColumn:Type := adDate
         CASE cType = "L" ; oColumn:Type := adBoolean
      ENDCASE
      oColumn:Attributes := adColNullable

      oTable:Columns:Append( oColumn )
   NEXT

   // add Table to Catalog
   oCatalog:Tables:Append( oTable )

   oConnect:ConnectionString = 'Provider=Microsoft.ACE.OLEDB.12.0;' + ;
           'Data Source=' + myXlsFile + ';' + ;
           'Extended Properties="Excel 12.0 Xml";'

   oConnect:open()

   SetProperty( "ExportDbf", "ProgressBar_1", "Value", 0 )

   SetCursorWait( "WinLeft", .T. )
   SetCursorWait( "WinRight", .T. )

   DO EVENTS

* #define Use_INSERT .T.
#ifdef Use_INSERT
   //  ---------------------- INSERT INTO ---------------------- *

   // prepare String for Fields
   cSelect := "( "
   ii := 1
   FOR ii := 1 TO iMax
      cField := aStructure[ ii ] [ DBS_NAME ]
      cSelect += cField
      IF ii < iMax
         cSelect += ", "
      ENDIF
   NEXT
   cSelect += " ) "

   // now start
   nStart := SECONDS()
   GO TOP
   DO WHILE !EOF()
      ii := 1
      cSql := "INSERT INTO [Sheet1] " + cSelect + "VALUES ( "

      FOR ii := 1 TO iMax
         cField := aStructure[ ii ] [ DBS_NAME ]
         cType := aStructure[ ii ] [ DBS_TYPE ]
         nPosi := FIELDPOS( cField )
         xValue := FIELDGET( nPosi )

         DO CASE
            CASE cType = "C"
               xValue := "'" + STRTRAN( xValue, "'", " " ) + "'"
            CASE cType = "M"
               IF LEN(xValue) > 64
                  xValue := "'Memo'"
               ELSE
                  xValue := "'" + STRTRAN( xValue, "'", " " ) + "'"
               ENDIF
            CASE cType = "D"
               * xValue := DTOC( xValue )
               xValue := DTOS( xValue ) + "000001"
               * xValue := HB_STOT( DTOS( xValue ) + "000000" )
            CASE cType = "L"
               xValue := IF( xValue = .T., "TRUE", "FALSE" )
            CASE cType = "N"
               xValue := STR( xValue )
         ENDCASE

         cSql += xValue
         IF ii < iMax
            cSql += ","
         ENDIF
      NEXT
      cSql += ")"
      oConnect:Execute( cSql )
      onDummy( TIME(), cSql )

      nRowLine ++
      IF ( nRowLine % nEvery ) = 0
         nProz := CalcPos( nRowLine, nMax )
         IF nProz > 100
            nProz := 100
         ENDIF
         SetProperty( "ExportDbf", "ProgressBar_1", "Value", nProz )
      ENDIF

      SKIP
   ENDDO

#ELSE
   //  ---------------------- ADO Recordset -------------------- *
ALTD()
   objRS := CreateObject( "ADODB.Recordset" )
   objRS:Open( "Select * from [Sheet1]", oConnect, adOpenKeyset, adLockOptimistic )

   // now start
   nStart := SECONDS()
   GO TOP
   DO WHILE !EOF()
      aField := {}
      aValue := {}
      ii := 1
      FOR ii := 1 TO iMax
         cField := aStructure[ ii ] [ DBS_NAME ]
         cType  := aStructure[ ii ] [ DBS_TYPE ]
         nPosi  := FIELDPOS( cField )
         xValue := FIELDGET( nPosi )

         IF EMPTY(xValue)
            DO CASE
               CASE cType = "C" ; xValue := ""
               CASE cType = "M" ; xValue := ""
               CASE cType = "N" ; xValue := 0.00
               CASE cType = "D" ; xValue := CTOD("  .  .  ")
               CASE cType = "L" ; xValue := .F.
            ENDCASE
         ENDIF
         AADD(aField,cField)
         AADD(aValue,xValue)
      NEXT
      objRS:AddNew(aField,aValue)
      objRS:Update()                             // objRS:UpdateBatch()

      nRowLine ++
      IF ( nRowLine % nEvery ) = 0
         nProz := CalcPos( nRowLine, nMax )
         IF nProz > 100
            nProz := 100
         ENDIF
         SetProperty( "ExportDbf", "ProgressBar_1", "Value", nProz )
         DO EVENTS
      ENDIF

      SKIP
   ENDDO

   objRS:Close()
   objRS := NIL

#ENDIF

   oConnect:Close()
   oConnect := NIL

   nStop := SECONDS() - nStart
   onDummy( TIME(), "finish after " + LTRIM( STR( nStop ) ) )

   oCatalog := NIL
   oTable   := NIL
   oColumn  := NIL

   hb_cdpSelect( cOldLang )

   SetCursorWait( "WinLeft", .F. )
   SetCursorWait( "WinRight", .F. )

   DO EVENTS

   Msginfo("finish after " + LTRIM( STR( nStop ) ))

RETURN .T.
